/*
 * Sixth Data. Author: Svjatoslav Agejenko. 
 * This project is released under Creative Commons Zero (CC0) license.
 *
*/

package eu.svjatoslav.sixth.data.model;

public class ArrayStorage {

    // load 16bit integer from byte array
    public static int load16bit(final byte[] array, final int addr) {
        // return (int)array[addr] + (int)array[addr+1]*256;
        return ((array[addr + 1] & 0xFF) << 8) | (array[addr] & 0xFF);
    }

    // load 16bit integer from byte array
    public static int load32bit(final byte[] array, final int addr) {
        return ((array[addr + 3] & 0xFF) << 24)
                | ((array[addr + 2] & 0xFF) << 16)
                | ((array[addr + 1] & 0xFF) << 8) | (array[addr] & 0xFF);
    }

    // store 16bit integer into byte array
    public static void store16bit(final byte[] array, final int addr,
                                  final int value) {
        final int byteHigh = value / 256;
        final int byteLow = value - (byteHigh * 256);
        array[addr] = (byte) byteLow;
        array[addr + 1] = (byte) byteHigh;
    }

}
